// This file was generated by KeywordLookupGenerator.py.  Do not edit.

#if CPU(NEEDS_ALIGNED_ACCESS)

#define COMPARE_CHARACTERS2(address, char1, char2) \
    (((address)[0] == char1) && ((address)[1] == char2))
#define COMPARE_CHARACTERS4(address, char1, char2, char3, char4) \
    (COMPARE_CHARACTERS2(address, char1, char2) && COMPARE_CHARACTERS2((address) + 2, char3, char4))

#else // CPU(NEEDS_ALIGNED_ACCESS)

#if CPU(BIG_ENDIAN)

#define CHARPAIR_TOUINT32(a, b) \
    ((((uint32_t)(a)) << 16) + (uint32_t)(b))
#define CHARQUAD_TOUINT64(a, b, c, d) \
    ((((uint64_t)(CHARPAIR_TOUINT32(a, b))) << 32) + CHARPAIR_TOUINT32(c, d))

#else // CPU(BIG_ENDIAN)

#define CHARPAIR_TOUINT32(a, b) \
    ((((uint32_t)(b)) << 16) + (uint32_t)(a))
#define CHARQUAD_TOUINT64(a, b, c, d) \
    ((((uint64_t)(CHARPAIR_TOUINT32(c, d))) << 32) + CHARPAIR_TOUINT32(a, b))

#endif // CPU(BIG_ENDIAN)


#define COMPARE_CHARACTERS2(address, char1, char2) \
    (((uint32_t*)(address))[0] == CHARPAIR_TOUINT32(char1, char2))

#if CPU(X86_64)

#define COMPARE_CHARACTERS4(address, char1, char2, char3, char4) \
    (((uint64_t*)(address))[0] == CHARQUAD_TOUINT64(char1, char2, char3, char4))

#else // CPU(X86_64)

#define COMPARE_CHARACTERS4(address, char1, char2, char3, char4) \
    (COMPARE_CHARACTERS2(address, char1, char2) && COMPARE_CHARACTERS2((address) + 2, char3, char4))

#endif // CPU(X86_64)

#endif // CPU(NEEDS_ALIGNED_ACCESS)

#define COMPARE_CHARACTERS3(address, char1, char2, char3) \
    (COMPARE_CHARACTERS2(address, char1, char2) && ((address)[2] == (char3)))
#define COMPARE_CHARACTERS5(address, char1, char2, char3, char4, char5) \
    (COMPARE_CHARACTERS4(address, char1, char2, char3, char4) && ((address)[4] == (char5)))
#define COMPARE_CHARACTERS6(address, char1, char2, char3, char4, char5, char6) \
    (COMPARE_CHARACTERS4(address, char1, char2, char3, char4) && COMPARE_CHARACTERS2(address + 4, char5, char6))
#define COMPARE_CHARACTERS7(address, char1, char2, char3, char4, char5, char6, char7) \
    (COMPARE_CHARACTERS4(address, char1, char2, char3, char4) && COMPARE_CHARACTERS4(address + 3, char4, char5, char6, char7))
#define COMPARE_CHARACTERS8(address, char1, char2, char3, char4, char5, char6, char7, char8) \
    (COMPARE_CHARACTERS4(address, char1, char2, char3, char4) && COMPARE_CHARACTERS4(address + 4, char5, char6, char7, char8))

namespace JSC {

static ALWAYS_INLINE bool isIdentPart(int c);
static const int maxTokenLength = 11;

template <bool shouldCreateIdentifier> ALWAYS_INLINE JSTokenType Lexer::parseKeyword(JSTokenData* data)
{
    ASSERT(m_codeEnd - m_code >= maxTokenLength);

    const UChar* code = m_code;
    if (code[0] == 'f') {
        if (COMPARE_CHARACTERS7(code + 1, 'u', 'n', 'c', 't', 'i', 'o', 'n')) {
            if (!isIdentPart(code[8])) {
                internalShift<8, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->functionKeyword;
                return FUNCTION;
            }
        } else if (COMPARE_CHARACTERS2(code + 1, 'o', 'r')) {
            if (!isIdentPart(code[3])) {
                internalShift<3, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->forKeyword;
                return FOR;
            }
        } else if (COMPARE_CHARACTERS4(code + 1, 'a', 'l', 's', 'e')) {
            if (!isIdentPart(code[5])) {
                internalShift<5, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->falseKeyword;
                return FALSETOKEN;
            }
        } else if (COMPARE_CHARACTERS6(code + 1, 'i', 'n', 'a', 'l', 'l', 'y')) {
            if (!isIdentPart(code[7])) {
                internalShift<7, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->finallyKeyword;
                return FINALLY;
            }
        }
    } else if (code[0] == 't') {
        if (code[1] == 'h') {
            if (COMPARE_CHARACTERS2(code + 2, 'i', 's')) {
                if (!isIdentPart(code[4])) {
                    internalShift<4, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->thisKeyword;
                    return THISTOKEN;
                }
            } else if (COMPARE_CHARACTERS4(code + 1, 'h', 'r', 'o', 'w')) {
                if (!isIdentPart(code[5])) {
                    internalShift<5, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->throwKeyword;
                    return THROW;
                }
            }
        } else if (code[1] == 'r') {
            if (COMPARE_CHARACTERS2(code + 2, 'u', 'e')) {
                if (!isIdentPart(code[4])) {
                    internalShift<4, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->trueKeyword;
                    return TRUETOKEN;
                }
            } else if (code[2] == 'y') {
                if (!isIdentPart(code[3])) {
                    internalShift<3, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->tryKeyword;
                    return TRY;
                }
            }
        } else if (COMPARE_CHARACTERS5(code + 1, 'y', 'p', 'e', 'o', 'f')) {
            if (!isIdentPart(code[6])) {
                internalShift<6, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->typeofKeyword;
                return TYPEOF;
            }
        }
    } else if (code[0] == 'i') {
        if (code[1] == 'f') {
            if (!isIdentPart(code[2])) {
                internalShift<2, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->ifKeyword;
                return IF;
            }
        } else if (code[1] == 'n') {
            if (!isIdentPart(code[2])) {
                internalShift<2, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->inKeyword;
                return INTOKEN;
            }
            if (COMPARE_CHARACTERS7(code + 2, 't', 'e', 'r', 'f', 'a', 'c', 'e')) {
                if (!isIdentPart(code[9])) {
                    internalShift<9, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->interfaceKeyword;
                    return RESERVED_IF_STRICT;
                }
            } else if (COMPARE_CHARACTERS8(code + 2, 's', 't', 'a', 'n', 'c', 'e', 'o', 'f')) {
                if (!isIdentPart(code[10])) {
                    internalShift<10, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->instanceofKeyword;
                    return INSTANCEOF;
                }
            }
        } else if (COMPARE_CHARACTERS2(code + 1, 'm', 'p')) {
            if (COMPARE_CHARACTERS4(code + 2, 'p', 'o', 'r', 't')) {
                if (!isIdentPart(code[6])) {
                    internalShift<6, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->importKeyword;
                    return RESERVED;
                }
            } else if (COMPARE_CHARACTERS7(code + 3, 'l', 'e', 'm', 'e', 'n', 't', 's')) {
                if (!isIdentPart(code[10])) {
                    internalShift<10, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->implementsKeyword;
                    return RESERVED_IF_STRICT;
                }
            }
        }
    } else if (code[0] == 'v') {
        if (COMPARE_CHARACTERS2(code + 1, 'a', 'r')) {
            if (!isIdentPart(code[3])) {
                internalShift<3, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->varKeyword;
                return VAR;
            }
        } else if (COMPARE_CHARACTERS4(code, 'v', 'o', 'i', 'd')) {
            if (!isIdentPart(code[4])) {
                internalShift<4, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->voidKeyword;
                return VOIDTOKEN;
            }
        }
    } else if (COMPARE_CHARACTERS6(code, 'r', 'e', 't', 'u', 'r', 'n')) {
        if (!isIdentPart(code[6])) {
            internalShift<6, DoNotBoundsCheck>();
            if (shouldCreateIdentifier)
                data->ident = &m_globalData->propertyNames->returnKeyword;
            return RETURN;
        }
    } else if (code[0] == 'n') {
        if (COMPARE_CHARACTERS4(code, 'n', 'u', 'l', 'l')) {
            if (!isIdentPart(code[4])) {
                internalShift<4, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->nullKeyword;
                return NULLTOKEN;
            }
        } else if (COMPARE_CHARACTERS2(code + 1, 'e', 'w')) {
            if (!isIdentPart(code[3])) {
                internalShift<3, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->newKeyword;
                return NEW;
            }
        }
    } else if (code[0] == 'e') {
        if (COMPARE_CHARACTERS4(code, 'e', 'l', 's', 'e')) {
            if (!isIdentPart(code[4])) {
                internalShift<4, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->elseKeyword;
                return ELSE;
            }
        } else if (code[1] == 'x') {
            if (COMPARE_CHARACTERS4(code + 2, 'p', 'o', 'r', 't')) {
                if (!isIdentPart(code[6])) {
                    internalShift<6, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->exportKeyword;
                    return RESERVED;
                }
            } else if (COMPARE_CHARACTERS5(code + 2, 't', 'e', 'n', 'd', 's')) {
                if (!isIdentPart(code[7])) {
                    internalShift<7, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->extendsKeyword;
                    return RESERVED;
                }
            }
        } else if (COMPARE_CHARACTERS4(code, 'e', 'n', 'u', 'm')) {
            if (!isIdentPart(code[4])) {
                internalShift<4, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->enumKeyword;
                return RESERVED;
            }
        }
    } else if (code[0] == 'c') {
        if (code[1] == 'a') {
            if (COMPARE_CHARACTERS4(code + 1, 'a', 't', 'c', 'h')) {
                if (!isIdentPart(code[5])) {
                    internalShift<5, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->catchKeyword;
                    return CATCH;
                }
            } else if (COMPARE_CHARACTERS2(code + 2, 's', 'e')) {
                if (!isIdentPart(code[4])) {
                    internalShift<4, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->caseKeyword;
                    return CASE;
                }
            }
        } else if (COMPARE_CHARACTERS2(code + 1, 'o', 'n')) {
            if (COMPARE_CHARACTERS5(code + 3, 't', 'i', 'n', 'u', 'e')) {
                if (!isIdentPart(code[8])) {
                    internalShift<8, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->continueKeyword;
                    return CONTINUE;
                }
            } else if (COMPARE_CHARACTERS2(code + 3, 's', 't')) {
                if (!isIdentPart(code[5])) {
                    internalShift<5, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->constKeyword;
                    return CONSTTOKEN;
                }
            }
        } else if (COMPARE_CHARACTERS4(code + 1, 'l', 'a', 's', 's')) {
            if (!isIdentPart(code[5])) {
                internalShift<5, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->classKeyword;
                return RESERVED;
            }
        }
    } else if (COMPARE_CHARACTERS5(code, 'b', 'r', 'e', 'a', 'k')) {
        if (!isIdentPart(code[5])) {
            internalShift<5, DoNotBoundsCheck>();
            if (shouldCreateIdentifier)
                data->ident = &m_globalData->propertyNames->breakKeyword;
            return BREAK;
        }
    } else if (code[0] == 'w') {
        if (COMPARE_CHARACTERS4(code + 1, 'h', 'i', 'l', 'e')) {
            if (!isIdentPart(code[5])) {
                internalShift<5, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->whileKeyword;
                return WHILE;
            }
        } else if (COMPARE_CHARACTERS4(code, 'w', 'i', 't', 'h')) {
            if (!isIdentPart(code[4])) {
                internalShift<4, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->withKeyword;
                return WITH;
            }
        }
    } else if (code[0] == 'd') {
        if (code[1] == 'e') {
            if (COMPARE_CHARACTERS5(code + 2, 'f', 'a', 'u', 'l', 't')) {
                if (!isIdentPart(code[7])) {
                    internalShift<7, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->defaultKeyword;
                    return DEFAULT;
                }
            } else if (COMPARE_CHARACTERS6(code + 2, 'b', 'u', 'g', 'g', 'e', 'r')) {
                if (!isIdentPart(code[8])) {
                    internalShift<8, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->debuggerKeyword;
                    return DEBUGGER;
                }
            } else if (COMPARE_CHARACTERS4(code + 2, 'l', 'e', 't', 'e')) {
                if (!isIdentPart(code[6])) {
                    internalShift<6, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->deleteKeyword;
                    return DELETETOKEN;
                }
            }
        } else if (code[1] == 'o') {
            if (!isIdentPart(code[2])) {
                internalShift<2, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->doKeyword;
                return DO;
            }
        }
    } else if (COMPARE_CHARACTERS5(code, 'y', 'i', 'e', 'l', 'd')) {
        if (!isIdentPart(code[5])) {
            internalShift<5, DoNotBoundsCheck>();
            if (shouldCreateIdentifier)
                data->ident = &m_globalData->propertyNames->yieldKeyword;
            return RESERVED_IF_STRICT;
        }
    } else if (code[0] == 'p') {
        if (code[1] == 'r') {
            if (COMPARE_CHARACTERS5(code + 2, 'i', 'v', 'a', 't', 'e')) {
                if (!isIdentPart(code[7])) {
                    internalShift<7, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->privateKeyword;
                    return RESERVED_IF_STRICT;
                }
            } else if (COMPARE_CHARACTERS7(code + 2, 'o', 't', 'e', 'c', 't', 'e', 'd')) {
                if (!isIdentPart(code[9])) {
                    internalShift<9, DoNotBoundsCheck>();
                    if (shouldCreateIdentifier)
                        data->ident = &m_globalData->propertyNames->protectedKeyword;
                    return RESERVED_IF_STRICT;
                }
            }
        } else if (COMPARE_CHARACTERS5(code + 1, 'u', 'b', 'l', 'i', 'c')) {
            if (!isIdentPart(code[6])) {
                internalShift<6, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->publicKeyword;
                return RESERVED_IF_STRICT;
            }
        } else if (COMPARE_CHARACTERS6(code + 1, 'a', 'c', 'k', 'a', 'g', 'e')) {
            if (!isIdentPart(code[7])) {
                internalShift<7, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->packageKeyword;
                return RESERVED_IF_STRICT;
            }
        }
    } else if (code[0] == 's') {
        if (COMPARE_CHARACTERS5(code + 1, 'w', 'i', 't', 'c', 'h')) {
            if (!isIdentPart(code[6])) {
                internalShift<6, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->switchKeyword;
                return SWITCH;
            }
        } else if (COMPARE_CHARACTERS5(code + 1, 't', 'a', 't', 'i', 'c')) {
            if (!isIdentPart(code[6])) {
                internalShift<6, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->staticKeyword;
                return RESERVED_IF_STRICT;
            }
        } else if (COMPARE_CHARACTERS4(code + 1, 'u', 'p', 'e', 'r')) {
            if (!isIdentPart(code[5])) {
                internalShift<5, DoNotBoundsCheck>();
                if (shouldCreateIdentifier)
                    data->ident = &m_globalData->propertyNames->superKeyword;
                return RESERVED;
            }
        }
    } else if (COMPARE_CHARACTERS3(code, 'l', 'e', 't')) {
        if (!isIdentPart(code[3])) {
            internalShift<3, DoNotBoundsCheck>();
            if (shouldCreateIdentifier)
                data->ident = &m_globalData->propertyNames->letKeyword;
            return RESERVED_IF_STRICT;
        }
    }
    return IDENT;
}

} // namespace JSC
